
#------------------------------------------------------------------------
# generate TermCap.m2 from /usr/etc/termcap and win/term
#
#------------------------------------------------------------------------

	PATH=/bin:/usr/bin
	tmp=ti$$
	tmp1=ti_$$
	tmp2=ti__$$

trap "rm -f $tmp $tmp1 $tmp2" 0 1 2 3 15
awk '
BEGIN	{ printf "BEGIN\n"
	bools =0; ints =0; nums = 0}
	{printf "	table[%d].sname := \"%s\";\n",NR -1 ,$2 
	printf "	table[%d].tag :=  %s;\n",NR -1 ,$1 
	if ($1== "bool")
	{ ++ bools;
	  printf "	table[%d].Bool := 'FALSE';\n" , NR -1
	}
	else
	if ($1 == "num")
	{ ++ ints;
	  printf "	table[%d].Number := -1;\n" , NR -1
	 }
	else   
	{ ++ strings
	  printf "	table[%d].Text[0] := 0C;\n" , NR -1}
	}
END	{ printf "\t anzstrings = %d;\n\t anzbools = %d;\n\t anzints =%d;", strings, bools, ints >"'$tmp2'"
	}
	'  t2 >$tmp
awk '
BEGIN		{
		lower = "abcdefghijklmnopqrstuvwxyz"
		upper = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
		longtab="           "
		}
		{
		if (NF == 3)
		{	split($3,comp,"_");
			head = substr(comp[1],1,1);
			tail = substr(comp[1],2);
			letter = index(lower,head);
			if (letter)
				head = substr(upper, letter,1);
			comp[1] = head tail;
			i=2; out = comp[1];
			while (comp[i] != "")
			{	head = substr(comp[i],1,1);
				
				tail = substr(comp[i],2);
				letter = index(lower,head);
				if (letter)
					head = substr(upper, letter,1);
				out = out head tail;
				++i;
			}
		}
		else 
		{
			out = $2;
			out = "T" out
		}
		if ($1 == "bool")
		   printf "%sterminfo.%s := captable[%d].Bool;\n", longtab, out, NR -1
		else if ( $1 == "num")
		   printf "%sterminfo.%s := captable[%d].Number;\n", longtab, out, NR -1
		else if ( $1 == "string")
		   printf "%sterminfo.%s := captable[%d].Text;\n", longtab, out, NR -1
		}
' t2 > $tmp1
ex TermCap.m1 >/dev/null <<eof
/CONST/
r $tmp2
/InitTable/
+
r $tmp
/InitTerm/
+
r $tmp1
w! TermCap.m2
eof
